<template>
    <main-master-page>
        <div class="recipe-view">
            <div v-if="currentItem">
                <h1>{{ currentItem.title }}</h1>
                <p>{{ currentItem.description }}</p>
                <div class="keywords">
                    <span v-for="(word, index) in currentItem.keywords" :key="index">{{ word }}</span>
                </div>
                <div class="image-container">
                    <img :src="currentItem.img" alt="No image" />
                </div>
            </div>
            <div v-else>
                <p class="not-found-message">Recipe not found</p>
            </div>
            <div class="buttons-container">
                <button class="edit-button" @click="onEdit(currentItem.id)">Edit</button>
            </div>
        </div>
    </main-master-page>
</template>

<script>
import { mapGetters } from 'vuex'
import MainMasterPage from '@/masterpages/MainMasterPage.vue';
export default {
    name: 'ViewRecipe',
    components: {
        MainMasterPage,
    },
    data() {
        return {
            currentItem: {}
        }
    },
    computed: {
        ...mapGetters('recipes', ['getItemById']),
        itemId() {
            return this.$route.params.itemId
        },

    },
    created() {
        if (this.itemId)
            this.currentItem = { ...this.getItemById(this.itemId) };
    },
    methods: {
        onEdit(editRecipeId) {
            this.$router.push({
                name: 'config', params: {
                    itemId: editRecipeId
                }
            })
        },
        goToDetailsPage(recipeId) {
            this.$router.push({ name: 'view', params: { itemId: recipeId } });
        },
    }
}
</script>

<style lang="scss" scoped>
.recipe-view {
    padding-left: 10vw;
    padding-right: 3vw;
    font-size: 150%;
    color: white;

    &__content {
        display: flex;
        flex-direction: column;
    }

    h1 {
        margin-bottom: 10px;
    }

    p {
        margin-bottom: 20px;
    }

    .keywords {
        display: flex;

        span {
            background-color: #4c9f70;
            color: #ffffff;
            padding: 5px 10px;
            margin-right: 10px;
            border-radius: 30px;
        }
    }

    .image-container {
        img {
            max-width: 30%;
            border-radius: 30px;
            margin-top: 20px;
        }
    }

    .not-found-message {
        color: #e74c3c;
    }

    .buttons-container {
        display: flex;
        margin-top: 1vh;
        gap: 1vw;

        .edit-button {
            background-color: transparent;
            border: 2px solid white;
            cursor: pointer;
            overflow: hidden;
            border-radius: 30px;
            font-size: 100%;
            color: white;
            padding: 10px 20px;
            transition: background-color 0.3s, color 0.3s, border-color 0.3s;
            appearance: none;
            outline: none;

            &:hover {
                background-color: white;
                transition: background-color 0.3s, color 0.3s, border-color 0.3s;
                color: green;
                border-color: transparent;
                border: 2px solid white;
            }
        }
    }
}
</style>
